Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
EggPoolUniquifier Class Reference

This is a specialization of EggNameUniquifier to generate unique names for textures, materials, and vertex pools prior to writing out an egg file. More...

`#include "eggPoolUniquifier.h"`

Inheritance diagram for EggPoolUniquifier:

## Public Member Functions
virtual TypeHandle | force_init_type ()
virtual std::string | get_category (EggNode *node)
| Returns the category name into which the given node should be collected, or the empty string if the node's name should be left alone.
virtual TypeHandle | get_type () const
Public Member Functions inherited from EggNameUniquifier
bool | add_name (const std::string &category, const std::string &name, EggNode *node=nullptr)
| Adds the name to the indicated category.
void | clear ()
| Empties the table of used named and prepares the Uniquifier for a new tree.
virtual std::string | filter_name (EggNode *node)
| Returns the name of the given node, or at least the name it should be.
virtual std::string | generate_name (EggNode *node, const std::string &category, int index)
| Generates a new name for the given node when its existing name clashes with some other node.
EggNode * | get_node (const std::string &category, const std::string &name) const
| Returns the node associated with the given category and name, or NULL if the name has not been used.
bool | has_name (const std::string &category, const std::string &name) const
| Returns true if the name has been used for the indicated category already, false otherwise.
void | uniquify (EggNode *node)
| Begins the traversal from the indicated node.
Public Member Functions inherited from EggObject
| EggObject (const EggObject &copy)
virtual EggTransform * | as_transform ()
| Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not.
void | clear_user_data ()
| Removes *all* user data pointers from the node.
void | clear_user_data (TypeHandle type)
| Removes the user data pointer of the indicated type.
EggUserData * | get_user_data () const
| Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored.
EggUserData * | get_user_data (TypeHandle type) const
| Returns the user data pointer of the indicated type, if it exists, or NULL if it does not.
bool | has_user_data () const
| Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise.
bool | has_user_data (TypeHandle type) const
| Returns true if the user data pointer of the indicated type has been set, false otherwise.
EggObject & | operator= (const EggObject &copy)
void | set_user_data (EggUserData *user_data)
| Sets the user data associated with this object.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggNameUniquifier
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

This is a specialization of EggNameUniquifier to generate unique names for textures, materials, and vertex pools prior to writing out an egg file.

It's automatically called by EggData prior to writing out an egg file.

Definition at line 26 of file eggPoolUniquifier.h.

## Constructor & Destructor Documentation

## ◆ EggPoolUniquifier()

EggPoolUniquifier::EggPoolUniquifier | ( |  | ) |

Definition at line 28 of file eggPoolUniquifier.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle EggPoolUniquifier::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from EggNameUniquifier.

Definition at line 44 of file eggPoolUniquifier.h.

## ◆ get_category()

std::string EggPoolUniquifier::get_category | ( | EggNode * | node | ) |
| virtual

Returns the category name into which the given node should be collected, or the empty string if the node's name should be left alone.

Implements EggNameUniquifier.

Definition at line 36 of file eggPoolUniquifier.cxx.

References TypedObject::is_of_type().

## ◆ get_class_type()

static TypeHandle EggPoolUniquifier::get_class_type | ( |  | ) |
| inline static

Definition at line 33 of file eggPoolUniquifier.h.

## ◆ get_type()

virtual TypeHandle EggPoolUniquifier::get_type | ( |  | ) | const
| inline virtual

Reimplemented from EggNameUniquifier.

Definition at line 41 of file eggPoolUniquifier.h.

## ◆ init_type()

static void EggPoolUniquifier::init_type | ( |  | ) |
| inline static

Definition at line 36 of file eggPoolUniquifier.h.

The documentation for this class was generated from the following files:

- panda/src/egg/eggPoolUniquifier.h
- panda/src/egg/eggPoolUniquifier.cxx